
_spiInit:

;ATtiny2313_AD7328_USI.c,3 :: 		void spiInit() {
;ATtiny2313_AD7328_USI.c,6 :: 		DDRB &= ~(1<<USI_DI); // 0 - input; 1 - output
	IN         R16, DDRB+0
	ANDI       R16, 223
	OUT        DDRB+0, R16
;ATtiny2313_AD7328_USI.c,9 :: 		DDRB |= ((1<<USI_DO) | (1<<USI_SCK) | (1<<USI_CS));
	ORI        R16, 208
	OUT        DDRB+0, R16
;ATtiny2313_AD7328_USI.c,12 :: 		USICR &= ~(1<<USIWM1);
	IN         R27, USICR+0
	CBR        R27, 32
	OUT        USICR+0, R27
;ATtiny2313_AD7328_USI.c,13 :: 		USICR |= (1<<USIWM0);
	IN         R16, USICR+0
	ORI        R16, 16
	OUT        USICR+0, R16
;ATtiny2313_AD7328_USI.c,16 :: 		PORTB |= ~(0<<USI_CS);
	IN         R16, PORTB+0
	ORI        R16, 255
	OUT        PORTB+0, R16
;ATtiny2313_AD7328_USI.c,18 :: 		return;
;ATtiny2313_AD7328_USI.c,19 :: 		}//spiInit
L_end_spiInit:
	RET
; end of _spiInit

_shft16bit:

;ATtiny2313_AD7328_USI.c,21 :: 		unsigned int shft16bit(unsigned int val) {
;ATtiny2313_AD7328_USI.c,26 :: 		higherByte = (unsigned char)((val & 0xFF00) >> 8);
	MOVW       R16, R2
	ANDI       R16, 0
	ANDI       R17, 255
	MOV        R18, R17
	LDI        R19, 0
;ATtiny2313_AD7328_USI.c,27 :: 		lowerByte  = (unsigned char)(val & 0x00FF);
	MOV        R16, R2
	ANDI       R16, 255
; lowerByte start address is: 17 (R17)
	MOV        R17, R16
;ATtiny2313_AD7328_USI.c,29 :: 		PORTB &= (0<<USI_CS); // CS low
	IN         R16, PORTB+0
	ANDI       R16, 0
	OUT        PORTB+0, R16
;ATtiny2313_AD7328_USI.c,31 :: 		USIDR = higherByte;
	OUT        USIDR+0, R18
;ATtiny2313_AD7328_USI.c,32 :: 		USISR |= (1<<USIOIF);
	IN         R27, USISR+0
	SBR        R27, 64
	OUT        USISR+0, R27
; lowerByte end address is: 17 (R17)
	MOV        R18, R17
;ATtiny2313_AD7328_USI.c,34 :: 		do {
	JMP        L_shft16bit0
L__shft16bit34:
;ATtiny2313_AD7328_USI.c,36 :: 		} while ((USISR & (1<<USIOIF)) == 0);
;ATtiny2313_AD7328_USI.c,34 :: 		do {
L_shft16bit0:
;ATtiny2313_AD7328_USI.c,35 :: 		USICR = CR;
; lowerByte start address is: 18 (R18)
; lowerByte start address is: 18 (R18)
; lowerByte end address is: 18 (R18)
	LDI        R27, 27
	OUT        USICR+0, R27
;ATtiny2313_AD7328_USI.c,36 :: 		} while ((USISR & (1<<USIOIF)) == 0);
	IN         R16, USISR+0
	ANDI       R16, 64
	CPI        R16, 0
	BRNE       L__shft16bit44
	JMP        L__shft16bit34
L__shft16bit44:
; lowerByte end address is: 18 (R18)
;ATtiny2313_AD7328_USI.c,38 :: 		res = USIDR << 8;
; lowerByte start address is: 18 (R18)
	IN         R16, USIDR+0
	MOV        R17, R16
	CLR        R16
; res start address is: 20 (R20)
	MOVW       R20, R16
;ATtiny2313_AD7328_USI.c,42 :: 		USIDR = lowerByte;
	OUT        USIDR+0, R18
; lowerByte end address is: 18 (R18)
;ATtiny2313_AD7328_USI.c,43 :: 		USISR |= (1<<USIOIF);
	IN         R16, USISR+0
	ORI        R16, 64
	OUT        USISR+0, R16
;ATtiny2313_AD7328_USI.c,45 :: 		do {
	JMP        L_shft16bit3
L__shft16bit35:
;ATtiny2313_AD7328_USI.c,47 :: 		} while ((USISR & (1<<USIOIF)) == 0);
;ATtiny2313_AD7328_USI.c,45 :: 		do {
L_shft16bit3:
;ATtiny2313_AD7328_USI.c,46 :: 		USICR = CR;
; res start address is: 20 (R20)
; res end address is: 20 (R20)
	LDI        R27, 27
	OUT        USICR+0, R27
;ATtiny2313_AD7328_USI.c,47 :: 		} while ((USISR & (1<<USIOIF)) == 0);
	IN         R16, USISR+0
	ANDI       R16, 64
	CPI        R16, 0
	BRNE       L__shft16bit45
	JMP        L__shft16bit35
L__shft16bit45:
; res end address is: 20 (R20)
;ATtiny2313_AD7328_USI.c,49 :: 		res |= USIDR;
; res start address is: 20 (R20)
	IN         R16, USIDR+0
	MOVW       R18, R20
	OR         R18, R16
	ORI        R19, 0
; res end address is: 20 (R20)
;ATtiny2313_AD7328_USI.c,51 :: 		PORTB |= ~(0<<USI_CS); // CS high
	IN         R16, PORTB+0
	ORI        R16, 255
	OUT        PORTB+0, R16
;ATtiny2313_AD7328_USI.c,53 :: 		return res;
	MOVW       R16, R18
;ATtiny2313_AD7328_USI.c,54 :: 		}//shft16bit
L_end_shft16bit:
	RET
; end of _shft16bit

_setRangeRegister:

;ATtiny2313_AD7328_USI.c,57 :: 		void setRangeRegister(unsigned char ch, unsigned char range) {
;ATtiny2313_AD7328_USI.c,58 :: 		unsigned int range_ = 0xA000;
	PUSH       R2
	PUSH       R3
; range_ start address is: 20 (R20)
	LDI        R20, 0
	LDI        R21, 160
;ATtiny2313_AD7328_USI.c,60 :: 		if ((ch < 0) || (ch > 7)) return;
	LDI        R27, 0
	CP         R2, R27
	BRSH       L__setRangeRegister47
	JMP        L__setRangeRegister38
L__setRangeRegister47:
	LDI        R16, 7
	CP         R16, R2
	BRSH       L__setRangeRegister48
	JMP        L__setRangeRegister37
L__setRangeRegister48:
	JMP        L_setRangeRegister8
; range_ end address is: 20 (R20)
L__setRangeRegister38:
L__setRangeRegister37:
	JMP        L_end_setRangeRegister
L_setRangeRegister8:
;ATtiny2313_AD7328_USI.c,62 :: 		switch (ch) {
; range_ start address is: 20 (R20)
	JMP        L_setRangeRegister9
;ATtiny2313_AD7328_USI.c,63 :: 		case 0:
L_setRangeRegister11:
;ATtiny2313_AD7328_USI.c,64 :: 		range_ &= CH0_MASK;
	MOVW       R18, R20
	ANDI       R18, 255
	ANDI       R19, 231
; range_ end address is: 20 (R20)
;ATtiny2313_AD7328_USI.c,65 :: 		range_ |= range << 11;
	LDI        R27, 11
	MOV        R16, R3
	LDI        R17, 0
L__setRangeRegister49:
	LSL        R16
	ROL        R17
	DEC        R27
	BRNE       L__setRangeRegister49
L__setRangeRegister50:
	OR         R16, R18
	OR         R17, R19
; range_ start address is: 16 (R16)
;ATtiny2313_AD7328_USI.c,66 :: 		break;
; range_ end address is: 16 (R16)
	JMP        L_setRangeRegister10
;ATtiny2313_AD7328_USI.c,67 :: 		case 1:
L_setRangeRegister12:
;ATtiny2313_AD7328_USI.c,68 :: 		range_ &= CH1_MASK;
; range_ start address is: 20 (R20)
	MOVW       R18, R20
	ANDI       R18, 255
	ANDI       R19, 249
; range_ end address is: 20 (R20)
;ATtiny2313_AD7328_USI.c,69 :: 		range_ |= range << 9;
	LDI        R27, 9
	MOV        R16, R3
	LDI        R17, 0
L__setRangeRegister51:
	LSL        R16
	ROL        R17
	DEC        R27
	BRNE       L__setRangeRegister51
L__setRangeRegister52:
	OR         R16, R18
	OR         R17, R19
; range_ start address is: 16 (R16)
;ATtiny2313_AD7328_USI.c,70 :: 		break;
; range_ end address is: 16 (R16)
	JMP        L_setRangeRegister10
;ATtiny2313_AD7328_USI.c,71 :: 		case 2:
L_setRangeRegister13:
;ATtiny2313_AD7328_USI.c,72 :: 		range_ &= CH2_MASK;
; range_ start address is: 20 (R20)
	MOVW       R18, R20
	ANDI       R18, 127
	ANDI       R19, 254
; range_ end address is: 20 (R20)
;ATtiny2313_AD7328_USI.c,73 :: 		range_ |= range << 7;
	LDI        R27, 7
	MOV        R16, R3
	LDI        R17, 0
L__setRangeRegister53:
	LSL        R16
	ROL        R17
	DEC        R27
	BRNE       L__setRangeRegister53
L__setRangeRegister54:
	OR         R16, R18
	OR         R17, R19
; range_ start address is: 16 (R16)
;ATtiny2313_AD7328_USI.c,74 :: 		break;
; range_ end address is: 16 (R16)
	JMP        L_setRangeRegister10
;ATtiny2313_AD7328_USI.c,75 :: 		case 3:
L_setRangeRegister14:
;ATtiny2313_AD7328_USI.c,76 :: 		range_ &= CH3_MASK;
; range_ start address is: 20 (R20)
	MOVW       R18, R20
	ANDI       R18, 159
	ANDI       R19, 255
; range_ end address is: 20 (R20)
;ATtiny2313_AD7328_USI.c,77 :: 		range_ |= range << 5;
	LDI        R27, 5
	MOV        R16, R3
	LDI        R17, 0
L__setRangeRegister55:
	LSL        R16
	ROL        R17
	DEC        R27
	BRNE       L__setRangeRegister55
L__setRangeRegister56:
	OR         R16, R18
	OR         R17, R19
; range_ start address is: 16 (R16)
;ATtiny2313_AD7328_USI.c,78 :: 		break;
; range_ end address is: 16 (R16)
	JMP        L_setRangeRegister10
;ATtiny2313_AD7328_USI.c,79 :: 		case 4:
L_setRangeRegister15:
;ATtiny2313_AD7328_USI.c,80 :: 		range_ = range & CH4_MASK;
	MOV        R18, R3
	LDI        R19, 0
	ANDI       R18, 255
	ANDI       R19, 231
;ATtiny2313_AD7328_USI.c,81 :: 		range_ |= range << 11;
	LDI        R27, 11
	MOV        R16, R3
	LDI        R17, 0
L__setRangeRegister57:
	LSL        R16
	ROL        R17
	DEC        R27
	BRNE       L__setRangeRegister57
L__setRangeRegister58:
	OR         R16, R18
	OR         R17, R19
; range_ start address is: 16 (R16)
;ATtiny2313_AD7328_USI.c,82 :: 		break;
; range_ end address is: 16 (R16)
	JMP        L_setRangeRegister10
;ATtiny2313_AD7328_USI.c,83 :: 		case 5:
L_setRangeRegister16:
;ATtiny2313_AD7328_USI.c,84 :: 		range_ = range & CH5_MASK;
	MOV        R18, R3
	LDI        R19, 0
	ANDI       R18, 255
	ANDI       R19, 249
;ATtiny2313_AD7328_USI.c,85 :: 		range_ |= range << 9;
	LDI        R27, 9
	MOV        R16, R3
	LDI        R17, 0
L__setRangeRegister59:
	LSL        R16
	ROL        R17
	DEC        R27
	BRNE       L__setRangeRegister59
L__setRangeRegister60:
	OR         R16, R18
	OR         R17, R19
; range_ start address is: 16 (R16)
;ATtiny2313_AD7328_USI.c,86 :: 		break;
; range_ end address is: 16 (R16)
	JMP        L_setRangeRegister10
;ATtiny2313_AD7328_USI.c,87 :: 		case 6:
L_setRangeRegister17:
;ATtiny2313_AD7328_USI.c,88 :: 		range_ = range & CH6_MASK;
	MOV        R18, R3
	LDI        R19, 0
	ANDI       R18, 127
	ANDI       R19, 254
;ATtiny2313_AD7328_USI.c,89 :: 		range_ |= range << 7;
	LDI        R27, 7
	MOV        R16, R3
	LDI        R17, 0
L__setRangeRegister61:
	LSL        R16
	ROL        R17
	DEC        R27
	BRNE       L__setRangeRegister61
L__setRangeRegister62:
	OR         R16, R18
	OR         R17, R19
; range_ start address is: 16 (R16)
;ATtiny2313_AD7328_USI.c,90 :: 		break;
; range_ end address is: 16 (R16)
	JMP        L_setRangeRegister10
;ATtiny2313_AD7328_USI.c,91 :: 		case 7:
L_setRangeRegister18:
;ATtiny2313_AD7328_USI.c,92 :: 		range_ = range & CH7_MASK;
	MOV        R18, R3
	LDI        R19, 0
	ANDI       R18, 159
	ANDI       R19, 255
;ATtiny2313_AD7328_USI.c,93 :: 		range_ |= range << 5;
	LDI        R27, 5
	MOV        R16, R3
	LDI        R17, 0
L__setRangeRegister63:
	LSL        R16
	ROL        R17
	DEC        R27
	BRNE       L__setRangeRegister63
L__setRangeRegister64:
	OR         R16, R18
	OR         R17, R19
; range_ start address is: 16 (R16)
;ATtiny2313_AD7328_USI.c,94 :: 		break;
; range_ end address is: 16 (R16)
	JMP        L_setRangeRegister10
;ATtiny2313_AD7328_USI.c,95 :: 		default: break;
L_setRangeRegister19:
; range_ start address is: 20 (R20)
	MOVW       R16, R20
	JMP        L_setRangeRegister10
;ATtiny2313_AD7328_USI.c,96 :: 		}//switch
L_setRangeRegister9:
	LDI        R27, 0
	CP         R2, R27
	BRNE       L__setRangeRegister65
	JMP        L_setRangeRegister11
L__setRangeRegister65:
	LDI        R27, 1
	CP         R2, R27
	BRNE       L__setRangeRegister66
	JMP        L_setRangeRegister12
L__setRangeRegister66:
	LDI        R27, 2
	CP         R2, R27
	BRNE       L__setRangeRegister67
	JMP        L_setRangeRegister13
L__setRangeRegister67:
	LDI        R27, 3
	CP         R2, R27
	BRNE       L__setRangeRegister68
	JMP        L_setRangeRegister14
L__setRangeRegister68:
	LDI        R27, 4
	CP         R2, R27
	BRNE       L__setRangeRegister69
	JMP        L_setRangeRegister15
L__setRangeRegister69:
	LDI        R27, 5
	CP         R2, R27
	BRNE       L__setRangeRegister70
	JMP        L_setRangeRegister16
L__setRangeRegister70:
	LDI        R27, 6
	CP         R2, R27
	BRNE       L__setRangeRegister71
	JMP        L_setRangeRegister17
L__setRangeRegister71:
	LDI        R27, 7
	CP         R2, R27
	BRNE       L__setRangeRegister72
	JMP        L_setRangeRegister18
L__setRangeRegister72:
	JMP        L_setRangeRegister19
; range_ end address is: 20 (R20)
L_setRangeRegister10:
;ATtiny2313_AD7328_USI.c,98 :: 		shft16bit(range_);
; range_ start address is: 16 (R16)
	MOVW       R2, R16
; range_ end address is: 16 (R16)
	CALL       _shft16bit+0
;ATtiny2313_AD7328_USI.c,101 :: 		}//setRangeRegister
;ATtiny2313_AD7328_USI.c,100 :: 		return;
;ATtiny2313_AD7328_USI.c,101 :: 		}//setRangeRegister
L_end_setRangeRegister:
	POP        R3
	POP        R2
	RET
; end of _setRangeRegister

_setControlRegister:

;ATtiny2313_AD7328_USI.c,103 :: 		void setControlRegister(unsigned char ch, unsigned int setup) {
;ATtiny2313_AD7328_USI.c,105 :: 		if ((ch < 0) || (ch > 7)) return;
	PUSH       R2
	PUSH       R3
	PUSH       R4
	LDI        R27, 0
	CP         R2, R27
	BRSH       L__setControlRegister74
	JMP        L__setControlRegister41
L__setControlRegister74:
	LDI        R16, 7
	CP         R16, R2
	BRSH       L__setControlRegister75
	JMP        L__setControlRegister40
L__setControlRegister75:
	JMP        L_setControlRegister22
L__setControlRegister41:
L__setControlRegister40:
	JMP        L_end_setControlRegister
L_setControlRegister22:
;ATtiny2313_AD7328_USI.c,107 :: 		setup |= ((ch & 0x07) << 10);
	MOV        R16, R2
	ANDI       R16, 7
	LDI        R27, 10
	LDI        R17, 0
L__setControlRegister76:
	LSL        R16
	ROL        R17
	DEC        R27
	BRNE       L__setControlRegister76
L__setControlRegister77:
	OR         R16, R3
	OR         R17, R4
	MOV        R3, R16
	MOV        R4, R17
;ATtiny2313_AD7328_USI.c,109 :: 		shft16bit(setup);
	MOVW       R2, R16
	CALL       _shft16bit+0
;ATtiny2313_AD7328_USI.c,112 :: 		}//setControlRegister
;ATtiny2313_AD7328_USI.c,111 :: 		return;
;ATtiny2313_AD7328_USI.c,112 :: 		}//setControlRegister
L_end_setControlRegister:
	POP        R4
	POP        R3
	POP        R2
	RET
; end of _setControlRegister

_ADC7328init:

;ATtiny2313_AD7328_USI.c,114 :: 		void ADC7328init(void) {
;ATtiny2313_AD7328_USI.c,115 :: 		unsigned char i = 0;
	PUSH       R2
	PUSH       R3
	PUSH       R4
;ATtiny2313_AD7328_USI.c,117 :: 		for (i = 0; i < 7; i++) setRangeRegister(i, BIP10); // Fill in both range registers
; i start address is: 17 (R17)
	LDI        R17, 0
; i end address is: 17 (R17)
L_ADC7328init23:
; i start address is: 17 (R17)
	CPI        R17, 7
	BRLO       L__ADC7328init79
	JMP        L_ADC7328init24
L__ADC7328init79:
	PUSH       R17
	CLR        R3
	MOV        R2, R17
	CALL       _setRangeRegister+0
	POP        R17
	MOV        R16, R17
	SUBI       R16, 255
	MOV        R17, R16
; i end address is: 17 (R17)
	JMP        L_ADC7328init23
L_ADC7328init24:
;ATtiny2313_AD7328_USI.c,118 :: 		setControlRegister(0, SETUP_1);                     // Control register
	LDI        R27, 48
	MOV        R3, R27
	LDI        R27, 128
	MOV        R4, R27
	CLR        R2
	CALL       _setControlRegister+0
;ATtiny2313_AD7328_USI.c,119 :: 		shft16bit(0xFE00);                                  // Sequence register (no kidding)
	LDI        R27, 0
	MOV        R2, R27
	LDI        R27, 254
	MOV        R3, R27
	CALL       _shft16bit+0
;ATtiny2313_AD7328_USI.c,122 :: 		}//ADC7328init
;ATtiny2313_AD7328_USI.c,121 :: 		return;
;ATtiny2313_AD7328_USI.c,122 :: 		}//ADC7328init
L_end_ADC7328init:
	POP        R4
	POP        R3
	POP        R2
	RET
; end of _ADC7328init

_main:
	LDI        R27, 255
	OUT        SPL+0, R27
	LDI        R27, 0
	OUT        SPL+1, R27
	IN         R28, SPL+0
	IN         R29, SPL+1
	SBIW       R28, 8
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	ADIW       R28, 1

;ATtiny2313_AD7328_USI.c,124 :: 		void main() {
;ATtiny2313_AD7328_USI.c,125 :: 		unsigned int result = 0;
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
;ATtiny2313_AD7328_USI.c,128 :: 		spiInit();
	CALL       _spiInit+0
;ATtiny2313_AD7328_USI.c,129 :: 		ADC7328init();
	CALL       _ADC7328init+0
;ATtiny2313_AD7328_USI.c,131 :: 		CLKPR = 0x80;
	LDI        R27, 128
	OUT        CLKPR+0, R27
;ATtiny2313_AD7328_USI.c,132 :: 		CLKPR = 0x00;
	LDI        R27, 0
	OUT        CLKPR+0, R27
;ATtiny2313_AD7328_USI.c,133 :: 		UART1_Init_Advanced(9600, _UART_NOPARITY, _UART_ONE_STOPBIT);
	LDI        R27, 51
	OUT        UBRRL+0, R27
	LDI        R27, 0
	OUT        UBRRH+0, R27
	CLR        R7
	CLR        R6
	CALL       _UART1_Init_Advanced+0
;ATtiny2313_AD7328_USI.c,134 :: 		Delay_ms(100);
	LDI        R18, 5
	LDI        R17, 15
	LDI        R16, 242
L_main26:
	DEC        R16
	BRNE       L_main26
	DEC        R17
	BRNE       L_main26
	DEC        R18
	BRNE       L_main26
;ATtiny2313_AD7328_USI.c,136 :: 		while (1) {
L_main28:
;ATtiny2313_AD7328_USI.c,137 :: 		result = shft16bit(0x0000) & 0x1FFF; // solely gets least 13 bits
	CLR        R2
	CLR        R3
	CALL       _shft16bit+0
	ANDI       R16, 255
	ANDI       R17, 31
; result start address is: 20 (R20)
	MOVW       R20, R16
;ATtiny2313_AD7328_USI.c,138 :: 		if ((result & 0x1000) >> 12) // bit12 = 1
	ANDI       R16, 0
	ANDI       R17, 16
	LDI        R27, 12
L__main81:
	LSR        R17
	ROR        R16
	DEC        R27
	BRNE       L__main81
L__main82:
	MOV        R27, R16
	OR         R27, R17
	BRNE       L__main83
	JMP        L_main30
L__main83:
;ATtiny2313_AD7328_USI.c,139 :: 		IntToStr(result & 0x0FFF, buffer);
	MOVW       R18, R28
	MOVW       R16, R20
	ANDI       R16, 255
	ANDI       R17, 15
; result end address is: 20 (R20)
	MOVW       R4, R18
	MOVW       R2, R16
	CALL       _IntToStr+0
	JMP        L_main31
L_main30:
;ATtiny2313_AD7328_USI.c,141 :: 		IntToStr((~result) & 0x0FFF, buffer);
; result start address is: 20 (R20)
	MOVW       R18, R28
	MOVW       R16, R20
	COM        R16
	COM        R17
; result end address is: 20 (R20)
	ANDI       R16, 255
	ANDI       R17, 15
	MOVW       R4, R18
	MOVW       R2, R16
	CALL       _IntToStr+0
L_main31:
;ATtiny2313_AD7328_USI.c,142 :: 		UART1_Write_Text(buffer);
	MOVW       R16, R28
	MOVW       R2, R16
	CALL       _UART1_Write_Text+0
;ATtiny2313_AD7328_USI.c,143 :: 		nl();
	LDI        R27, 13
	MOV        R2, R27
	CALL       _UART1_Write+0
	LDI        R27, 10
	MOV        R2, R27
	CALL       _UART1_Write+0
;ATtiny2313_AD7328_USI.c,144 :: 		Delay_ms(250);
	LDI        R18, 11
	LDI        R17, 38
	LDI        R16, 94
L_main32:
	DEC        R16
	BRNE       L_main32
	DEC        R17
	BRNE       L_main32
	DEC        R18
	BRNE       L_main32
	NOP
	NOP
;ATtiny2313_AD7328_USI.c,145 :: 		}//while
	JMP        L_main28
;ATtiny2313_AD7328_USI.c,148 :: 		}//main
L_end_main:
	POP        R5
	POP        R4
	POP        R3
	POP        R2
L__main_end_loop:
	JMP        L__main_end_loop
; end of _main
